/*-------------------------------------------------------------------------
 Copyright 2009 Olivier Berlanger

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 -------------------------------------------------------------------------*/
package net.sf.sfac.gui.editor.cmp;


import java.util.List;


/**
 * This interface is used to create a new object when you know that the object to create are sub-classes of the class known by
 * the interface. <br>
 * Typically, there is a 'add' button that will display a popup menu to choose the specific object type (among the available
 * object types provided by this interface). When this type is chosen, the adding code asks this interface to create the new
 * object.
 * 
 * @author Olivier Berlanger
 */
public interface PolymorphicObjectFactory {


    public List<String> getAvailableObjectTypes(Class<?> baseType);


    public Object newIntance(String objectType);


}
