/*-------------------------------------------------------------------------
 Copyright 2009 Olivier Berlanger

 Licensed under the Apache License, Version 2.0 (the "License");
 you may not use this file except in compliance with the License.
 You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 Unless required by applicable law or agreed to in writing, software
 distributed under the License is distributed on an "AS IS" BASIS,
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 See the License for the specific language governing permissions and
 limitations under the License.
 -------------------------------------------------------------------------*/
package net.sf.sfac.gui.utils;


import javax.swing.AbstractButton;
import javax.swing.ButtonGroup;
import javax.swing.ButtonModel;


@SuppressWarnings("serial")
public class IndexedButtonGroup extends ButtonGroup {


    public int getSelectedIndex() {
        ButtonModel sel = getSelection();
        int i, len = buttons.size();
        for (i = 0; i < len; i++) {
            if (buttons.elementAt(i).getModel() == sel) return i;
        }
        return -1;
    }


    public void reset() {
        AbstractButton but = buttons.lastElement();
        if (but != null) {
            setSelected(but.getModel(), true);
            remove(but);
            but.setSelected(false);
            add(but);
        }
    }


}
